#pragma once
#include "resource.h"       // main symbols
#include "ECrmAddIn.h"
#include "IClientAddInImpl.h"
#include "IContactHandlerImpl.h"

class ATL_NO_VTABLE CContactHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CContactHandler, &CLSID_ContactHandler >
	, public IClientAddInImpl < CContactHandler >
	, public IContactHandlerImpl < CContactHandler >
{
public:
	CContactHandler(void);

DECLARE_REGISTRY_RESOURCEID(IDR_CONTACTHANDLER)

BEGIN_COM_MAP(CContactHandler)
	COM_INTERFACE_ENTRY(IClientAddIn)
	COM_INTERFACE_ENTRY_CHAIN(IContactHandlerImpl < CContactHandler >)
END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IContactHandler Implementation
	STDMETHOD(OnRegisterHandler) (
		/*[out, retval]*/ VARIANT* pvarAddInName);
	STDMETHOD(OnContactNewExecute) (
		/*[in]*/ BSTR       bstrFolderID,
		/*[in]*/ IDispatch* pContactOSP);
	STDMETHOD (OnContactOpen) (
		/*[in]*/ IDispatch* pContactOSP);
};

OBJECT_ENTRY_AUTO(__uuidof(ContactHandler), CContactHandler)
