// ActiveXTab.cpp : Implementation of CActiveXTab
#include "stdafx.h"
#include <AtlSafe.h>
#include "ActiveXTab.h"

// CActiveXTab
CActiveXTab::CActiveXTab()
{
	m_bWindowOnly = TRUE;
}

LRESULT CActiveXTab::OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	ATLTRACE2(atlTraceWindowing, 1, _T("CActiveXTab::OnCreate() m_hWnd = %#.8x\n"), m_hWnd);
	return 0;
}

// GRUNDSATZ:
//   ActiveX Controls malen sich ausschliesslich UND vollstaendig inkl. hintergrund im OnDraw() (MetaDraw)
// Windowed ActiveX Controls sind Windows/HWND und verhalten sich konsequent auch so
// es kann nicht 100% verhindert werden das so mancher container hier ein InvalidateWindow ausloest
// damit es nicht zu unnoetigen zeichenoperationen/flackern kommt schalten wir das aus
LRESULT CActiveXTab::OnEraseBkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
	ATLTRACE2(atlTraceWindowing, 1, _T("CActiveXTab::OnEraseBkgnd() m_hWnd = %#.8x\n"), m_hWnd);
	return TRUE;
}

/*
 * Hinweis: ProCall (als Container) nimmt es sich hier heraus die WDM funktionalitaet (Glass, Blur)
 * ueber die standardmaessig NCArea hinaus auf die gesamte Client Area auszudehnen.
 * dadurch wird jegliches simple drawing hier ebenfals diese effekte zeigen
 * dieser unplanbare effekt betrifft somit jeglichen client der im ProCall gehosted wird
 */
HRESULT CActiveXTab::OnDraw(ATL_DRAWINFO& di)
{
	RECT& rc = *(RECT*)di.prcBounds;
	// Set Clip region to the rectangle specified by di.prcBounds
	HRGN hRgnOld = NULL;
	if (GetClipRgn(di.hdcDraw, hRgnOld) != 1)
		hRgnOld = NULL;
	bool bSelectOldRgn = false;

	HRGN hRgnNew = CreateRectRgn(rc.left, rc.top, rc.right, rc.bottom);

	if (hRgnNew != NULL)
	{
		bSelectOldRgn = (SelectClipRgn(di.hdcDraw, hRgnNew) != ERROR);
	}

	Rectangle(di.hdcDraw, rc.left, rc.top, rc.right, rc.bottom);
	SetTextAlign(di.hdcDraw, TA_CENTER|TA_BASELINE);
	CString strText = _T("ATL 8.0 : ActiveXTab : ");
	strText.Append(m_bstrContainerObj);
	#ifndef _WIN32_WCE
	TextOut(di.hdcDraw,
		(rc.left + rc.right) / 2,
		(rc.top + rc.bottom) / 2,
		(LPCTSTR) strText,
		strText.GetLength());
	#else
	ExtTextOut(di.hdcDraw,
		(rc.left + rc.right) / 2,
		(rc.top + rc.bottom) / 2,
		ETO_OPAQUE,
		NULL,
		pszText,
		ATL::lstrlen(pszText),
		NULL);
	#endif

	if (bSelectOldRgn)
		SelectClipRgn(di.hdcDraw, hRgnOld);

	return S_OK;
}

// IOleObjectImpl overrides
HRESULT CActiveXTab::IOleObject_SetClientSite(IOleClientSite* pClientSite)
{
	HRESULT hRes = __super::IOleObject_SetClientSite(pClientSite);

	try
	{
		HRESULT hr = NOERROR;

		// dieser zugriff funktioniert IMMER fuer ein DIREKT von CActiveXHost gehostetes Control
		// evtl. koennte man hier ein zusaetzliches ConfigurationsFlag z.b. EnableDataModel schaffen
		CComQIPtr<IDocHostUIHandler> spDocHostUIHandler(pClientSite);
		CComPtr<IDispatch> spExternal;
		if(spDocHostUIHandler)
			hr = spDocHostUIHandler->GetExternal(&spExternal);

		IServiceProviderPtr spSP(pClientSite);
		if(NULL != spSP)
		{
			// http://msdn.microsoft.com/en-us/library/aa768181(VS.85).aspx
			IInternetHostSecurityManagerPtr spIHSM;
			hr = spSP->QueryService(__uuidof(IInternetHostSecurityManager), __uuidof(IInternetHostSecurityManager), (void**) &spIHSM);
			BYTE rgPolicy[0x10];
			BYTE* pPolicy = rgPolicy;
			DWORD dwPolicy = sizeof(rgPolicy);
			CONFIRMSAFETY CS;
			// hr = spIHSM->QueryCustomPolicy(GUID_CUSTOM_CONFIRMOBJECTSAFETY, &pPolicy, &dwPolicy, (BYTE*) &CS, sizeof(CS), 0);
		}

		// http://msdn.microsoft.com/en-us/library/aa768180(VS.85).aspx
		IBindHostPtr spBH(pClientSite);

		if(NULL != pClientSite)
		{
			// get containing IHTMLDocument2 reference
			IOleContainerPtr spContainer;
			hr = pClientSite->GetContainer(&spContainer);
			CComQIPtr<IHTMLDocument2> spDoc(spContainer);
			if(NULL != spDoc)
			{
				CComPtr<IHTMLWindow2> spWindow;
				hr = spDoc->get_parentWindow(&spWindow);
				if (FAILED(hr))
					_com_issue_error(hr);

				hr = spWindow->get_external(&spExternal);
			}
		}

		// examine our datamodel
		CComDispatchDriver dd(spExternal);
		if(dd)
		{
			CComVariant varApplication;
			hr = dd.GetPropertyByName(L"Application", &varApplication);
		}
	}
	catch(const _com_error& e)
	{
		e;
	}

	return hRes;
}

STDMETHODIMP CActiveXTab::SetHostNames(
	LPCOLESTR szContainerApp,
	LPCOLESTR szContainerObj)
{
	m_bstrContainerApp = szContainerApp;
	m_bstrContainerObj = szContainerObj;

	HRESULT hr = NOERROR;
	ATLTRACE(atlTraceControls,3,_T("0x%.8x = CActiveXTab::IOleObject::SetHostNames()\n"), hr);
	return hr;
}
