// ActiveXTab.h : Declaration of the CActiveXTab
#pragma once
#include "resource.h"       // main symbols
#include <atlctl.h>
#include "EProCallExt.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif


// CActiveXTab
class ATL_NO_VTABLE CActiveXTab :
	public CComObjectRootEx<CComSingleThreadModel>,
	public IPersistStreamInitImpl<CActiveXTab>,
	public IOleControlImpl<CActiveXTab>,
	public IOleObjectImpl<CActiveXTab>,
	public IOleInPlaceActiveObjectImpl<CActiveXTab>,
	public IViewObjectExImpl<CActiveXTab>,
	public IOleInPlaceObjectWindowlessImpl<CActiveXTab>,
	public IPersistStorageImpl<CActiveXTab>,
	public ISpecifyPropertyPagesImpl<CActiveXTab>,
	public IQuickActivateImpl<CActiveXTab>,
#ifndef _WIN32_WCE
	public IDataObjectImpl<CActiveXTab>,
#endif
	public IProvideClassInfo2Impl<&CLSID_ActiveXTab, NULL>,
#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
	public IObjectSafetyImpl<CActiveXTab, INTERFACESAFE_FOR_UNTRUSTED_CALLER>,
#endif
	public CComCoClass<CActiveXTab, &CLSID_ActiveXTab>,
	public CComControl<CActiveXTab>
{
public:
	CActiveXTab();

	HRESULT OnDraw(ATL_DRAWINFO& di);

	DECLARE_OLEMISC_STATUS(OLEMISC_RECOMPOSEONRESIZE |
		OLEMISC_CANTLINKINSIDE |
		OLEMISC_INSIDEOUT |
		OLEMISC_ACTIVATEWHENVISIBLE |
		OLEMISC_SETCLIENTSITEFIRST
	)

	DECLARE_REGISTRY_RESOURCEID(IDR_ACTIVEXTAB)
	DECLARE_PROTECT_FINAL_CONSTRUCT()

	BEGIN_COM_MAP(CActiveXTab)
		COM_INTERFACE_ENTRY(IViewObjectEx)
		COM_INTERFACE_ENTRY(IViewObject2)
		COM_INTERFACE_ENTRY(IViewObject)
		COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
		COM_INTERFACE_ENTRY(IOleInPlaceObject)
		COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
		COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
		COM_INTERFACE_ENTRY(IOleControl)
		COM_INTERFACE_ENTRY(IOleObject)
		COM_INTERFACE_ENTRY(IPersistStreamInit)
		COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
		COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
		COM_INTERFACE_ENTRY(IQuickActivate)
		COM_INTERFACE_ENTRY(IPersistStorage)
	#ifndef _WIN32_WCE
		COM_INTERFACE_ENTRY(IDataObject)
	#endif
		COM_INTERFACE_ENTRY(IProvideClassInfo)
		COM_INTERFACE_ENTRY(IProvideClassInfo2)
	#ifdef _WIN32_WCE // IObjectSafety is required on Windows CE for the control to be loaded correctly
		COM_INTERFACE_ENTRY_IID(IID_IObjectSafety, IObjectSafety)
	#endif
	END_COM_MAP()

	BEGIN_PROP_MAP(CActiveXTab)
		PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
		PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
		// Example entries
		// PROP_ENTRY("Property Description", dispid, clsid)
		// PROP_PAGE(CLSID_StockColorPage)
	END_PROP_MAP()

	BEGIN_MSG_MAP(CActiveXTab)
		MESSAGE_HANDLER(WM_CREATE, OnCreate)
		MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
		CHAIN_MSG_MAP(CComControl<CActiveXTab>)
		DEFAULT_REFLECTION_HANDLER()
	END_MSG_MAP()
	// Handler prototypes:
	//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
	//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);
	LRESULT OnCreate(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);
	LRESULT OnEraseBkgnd(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/);

	// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)

	// IOleObjectImpl overrides
	HRESULT IOleObject_SetClientSite(IOleClientSite *pClientSite);
	STDMETHOD(SetHostNames)(LPCOLESTR szContainerApp, LPCOLESTR szContainerObj);

	// Attributes
	CComBSTR m_bstrContainerApp;
	CComBSTR m_bstrContainerObj;
};

OBJECT_ENTRY_AUTO(__uuidof(ActiveXTab), CActiveXTab)
