// CtxMnuHandler.h : Declaration of the CCtxMnuHandler

#pragma once
#include "resource.h"       // main symbols

#define INITGUID
#include "InitGuid.h"
#include "EProCallExt.h"
#include "MenuGroupGUIDS.h"

#if defined(_WIN32_WCE) && !defined(_CE_DCOM) && !defined(_CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA)
#error "Single-threaded COM objects are not properly supported on Windows CE platform, such as the Windows Mobile platforms that do not include full DCOM support. Define _CE_ALLOW_SINGLE_THREADED_OBJECTS_IN_MTA to force ATL to support creating single-thread COM object's and allow use of it's single-threaded COM object implementations. The threading model in your rgs file was set to 'Free' as that is the only threading model supported in non DCOM Windows CE platforms."
#endif

// CCtxMnuHandler
class ATL_NO_VTABLE CCtxMnuHandler :
	  public CComObjectRootEx < CComSingleThreadModel >
	, public CComCoClass < CCtxMnuHandler, &CLSID_CtxMnuHandler >
	, public ECtiClientLib::IClientAddIn
	, public IDispatchImpl < ECtiClientLib::ICtxMnuHandler, &__uuidof(ECtiClientLib::ICtxMnuHandler), &__uuidof(ECtiClientLib::__ECtiClientLib) >
{
public:
	DECLARE_REGISTRY_RESOURCEID(IDR_CTXMNUHANDLER)

	BEGIN_COM_MAP(CCtxMnuHandler)
		COM_INTERFACE_ENTRY(ECtiClientLib::IClientAddIn)
		COM_INTERFACE_ENTRY(ECtiClientLib::ICtxMnuHandler)
		COM_INTERFACE_ENTRY2(IDispatch, ECtiClientLib::ICtxMnuHandler)
	END_COM_MAP()

	DECLARE_PROTECT_FINAL_CONSTRUCT()

	// IClientAddIn interface
	STDMETHOD(raw_GetAbout) (/*out*/ BSTR* pbstrAbout, /*out*/ BSTR* pbstrInfo);
	STDMETHOD(raw_OnLoad) (/*in*/ IDispatch* pClientApplication) { return E_NOTIMPL; }
	STDMETHOD(raw_OnUnload) () { return E_NOTIMPL; }

	// ICtxMnuHandler interface
	STDMETHOD(raw_OnCtxMenuCreate) (
		/*[in]*/ IDispatch* pCmdBar,
		/*[in]*/ IDispatch* pContacts)
	{
		ECtiClientLib::IPCCmdBarPtr spCmdBar(pCmdBar);

		LPOLESTR szGroupGUID = NULL;
		HRESULT hr = ::StringFromCLSID ((REFGUID) CONTACT_NEW_GROUP_GUID, &szGroupGUID);
		hr = spCmdBar->raw_Add(szGroupGUID, 0x38f5, L"&SMS Me", 0, _bstr_t());
		::CoTaskMemFree(szGroupGUID);
		return hr;
	}

	STDMETHOD(raw_OnCtxMenuItemClicked) (
		/*[in]*/ long       lCmdID,
		/*[in]*/ IDispatch* pContacts)
	{
		HRESULT hr = E_FAIL;
		try
		{
			ECtiClientLib::IECOMContactsPtr spContacts(pContacts);
			switch (lCmdID)
			{
				case 0x38f5:
					{
					ECtiClientLib::IECOMContactPtr spFirstContact(spContacts->Item[1]);
					TCHAR szMsg[0x100];
					_sntprintf_s(szMsg, 0xff, _T("FromInsideAddIn::OnCtxMenuItemClicked() on (%d items) FirstContact is: %ls"), spContacts->Count, (BSTR) spFirstContact->DisplayName);
					szMsg[0xff] = _T('\0');
					::MessageBox(NULL, szMsg, _T("SDK Sample ContextMenuHandler"), MB_OK | MB_ICONINFORMATION);
					hr = NOERROR;
					break;
					}

				default:
					hr = E_INVALIDARG;
					break;
			}
		}
		catch(const _com_error& e)
		{
			hr = e.Error();
		}

		return hr;
	}
};

OBJECT_ENTRY_AUTO(__uuidof(CtxMnuHandler), CCtxMnuHandler)
