// FindContacts.cpp : Implementation of CFindContacts

#include "stdafx.h"
#include <simpdata.h>
#include "FindContacts.h"

// CFindContacts
HRESULT CFindContacts::FinalConstruct()
{
	ATLTRACE2(atlTraceRefcount, 1, _T("CFindContacts::FinalConstruct()\n"));
	return S_OK;
}

void CFindContacts::FinalRelease()
{
	ATLTRACE2(atlTraceRefcount, 1, _T("CFindContacts::FinalRelease()\n"));
}

// IFindContacts implementation
STDMETHODIMP CFindContacts::raw_OnFindContacts(
	/*[in]*/ IDispatch* pFindOptions,
	/*[in]*/ IDispatch* pContactOSP)
{
	HRESULT hr = E_INVALIDARG;
	CComQIPtr<OLEDBSimpleProvider> spOSP(pContactOSP);
	if(spOSP)
	{
		ECtiClientLib::IFindOptionsPtr spFindOptions(pFindOptions);
		CComBSTR bstrPhoneNo;
		hr = spFindOptions->get_PhoneNo(&bstrPhoneNo);
		if(wcsstr(bstrPhoneNo, L"1234"))
		{
			DBROWCOUNT cRowsInserted = 0;
			hr = spOSP->insertRows(1, 1, &cRowsInserted);

			// eins
			hr = spOSP->setVariant(1,  1, OSPFORMAT_DEFAULT, CComVariant(_T("DB24")));                     // EntryIDDB
			hr = spOSP->setVariant(1,  2, OSPFORMAT_DEFAULT, CComVariant(_T("EProCallExt.FindContacts"))); // EntryIDStore);
			hr = spOSP->setVariant(1,  3, OSPFORMAT_DEFAULT, CComVariant(_T("1")));                        // EntryID);

			hr = spOSP->setVariant(1,  4, OSPFORMAT_DEFAULT, CComVariant(_T("Herr Max Mustermann")));      // DisplayName);
			hr = spOSP->setVariant(1,  5, OSPFORMAT_DEFAULT, CComVariant(_T("Max")));                      // FirstName);
			hr = spOSP->setVariant(1,  6, OSPFORMAT_DEFAULT, CComVariant(_T("Mustermann")));               // LastName);
			hr = spOSP->setVariant(1,  8, OSPFORMAT_DEFAULT, CComVariant(_T("Ich AG")));                   // Company);
			hr = spOSP->setVariant(1, 32, OSPFORMAT_DEFAULT, CComVariant(_T("1234")));                     // PhoneBusiness);
		}

		if(wcsstr(bstrPhoneNo, L"5678"))
		{
			DBROWCOUNT cRowsInserted = 0;
			hr = spOSP->insertRows(1, 1, &cRowsInserted);

			// zwei
			hr = spOSP->setVariant(1,  1, OSPFORMAT_DEFAULT, CComVariant(_T("DB24")));                     // EntryIDDB
			hr = spOSP->setVariant(1,  2, OSPFORMAT_DEFAULT, CComVariant(_T("EProCallExt.FindContacts"))); // EntryIDStore);
			hr = spOSP->setVariant(1,  3, OSPFORMAT_DEFAULT, CComVariant(_T("2")));                        // EntryID);

			hr = spOSP->setVariant(1,  4, OSPFORMAT_DEFAULT, CComVariant(_T("Herr Giesela Zickig")));      // DisplayName);
			hr = spOSP->setVariant(1,  5, OSPFORMAT_DEFAULT, CComVariant(_T("Giesela")));                  // FirstName);
			hr = spOSP->setVariant(1,  6, OSPFORMAT_DEFAULT, CComVariant(_T("Zickig")));                   // LastName);
			hr = spOSP->setVariant(1,  8, OSPFORMAT_DEFAULT, CComVariant(_T("Emma e.v.")));                // Company);
			hr = spOSP->setVariant(1, 32, OSPFORMAT_DEFAULT, CComVariant(_T("5678")));                     // PhoneBusiness);
		}

		hr = NOERROR;
	}
	else
		hr = E_INVALIDARG;

	ATLTRACE2(atlTraceGeneral, 1, _T("0x%.8x = CFindContacts::OnFindContacts()\n"), hr);
	return hr;
}
