// IMPORTANT:
//   using the "Microsoft.ACE.OLEDB.12.0" Provider on x64 machines it is required to use SYSWOW64 version of cscript.exe
//   c:\windows\syswow64\cscript.exe JournalDS.js
// C:\Program Files (x86)\Microsoft Visual Studio 8\VC\PlatformSDK\Bin\RowsetViewer.exe
var oTestCase = new CJournal;
var lRetC = oTestCase.Run();
oTestCase = null;

WScript.Quit(lRetC);

// constructor
function CJournal()
{
  // class members
  this.Run = Run;
  this.TestBind = TestBind;
  this.TestGetObject = TestGetObject;
  this.PrepareConnection_ForMSAccess = PrepareConnection_ForMSAccess;
  this.PrepareConnection_ForJournalOSP = PrepareConnection_ForJournalOSP;
  this.UsingCommand = UsingCommand;
  this.DumpRecordSet = DumpRecordSet;
  this.DumpFields = DumpFields;
  this.DumpRecord = DumpRecord;
  this.DumpJournalRecord = DumpJournalRecord;
  this.TRACE = TRACE;

  this.m_lRetC = 0;
}

// test New ActiveObject
function TestBind()
{
  this.TRACE("TestBind()");

  // http://msdn.microsoft.com/en-us/library/ms675532(VS.85).aspx
  // Handling ADO Events
  //   http://msdn.microsoft.com/en-us/library/ms681467(VS.85).aspx
  // Microsoft JScript does not support ADO events.
  //   http://msdn.microsoft.com/en-us/library/ms677581(VS.85).aspx
  var oCon = new ActiveXObject("ADODB.Connection");
  // PrepareConnection_ForMSAccess(oCon);
  PrepareConnection_ForJournalOSP(oCon);
  this.TRACE("using " + oCon.Provider);
  // this.UsingCommand(oCon);
  oCon.Open();

  var oRS = new ActiveXObject("ADODB.Recordset");
  // the first parameter of ADODB.Recordset::Open() is the DataMember parameter of IDataSource::getDataMember()
  // oRS.Open("lines", oCon);
  
  var strDataMember = "CLSID:432FED4F-B413-4040-A10F-ED92969A2AC0:!Journal:JournalCtxMenu:";
  if (1 <= WScript.Arguments.length)
    strDataMember = WScript.Arguments(0);

  oRS.Open(strDataMember, oCon);
  this.DumpFields(oRS);
  this.DumpRecordSet(oRS);
}

function TestGetObject()
{
  this.TRACE("TestGetObject()");

  // um einen AKTUELL gueltige ConnectionID zu erhalten am besten
  // TestBind laufen lassen und die ausgegebene ConnectionID hier rein pasten
  var oJournalItem = GetObject("CLSID:432FED4F-B413-4040-A10F-ED92969A2AC0:!Journal:CID0C4775B8CCCD8C43A44F9784A4A56A6F|tapi-25:");
  // ACHTUNG:
  //   collection ist VB maessig 1 based (so ist es implementiert)
  //   collection ist .NET maessig 0 Based
  WScript.Echo("oJournalItem.Item(1).GetFieldValue(ContactName): " + oJournalItem.Item(1).GetFieldValue("ContactName"));
}

function UsingCommand(oConnection)
{
	this.TRACE("UsingCommand()");
	
	var oCmd = new ActiveXObject("ADODB.Command");
	oCmd.ActiveConnection = oConnection;
	
	oCmd.CommandText = "ESTOS Query Syntax";
	// oCmd.Dialect = "{C8B521FB-5CF3-11CE-ADE5-00AA0044773D}"; // default indicates that the provider should choose how to interpret the command text or stream.
	oCmd.CommandType = 8; // 8 == adCmdUnknown, Default. Indicates that the type of command in the CommandText property is not known.
	
	/* var oParam = oCmd.CreateParameter("StartTime", Type, Direction, Size, Value); // Parameter uebergeben
	oCmd.Parameters.Append oParam;
	oParam.Value = "12:00:00"; */
	var nRecordsAffected = 0;
	var rgParams;
	var oRS = oCmd.Execute(nRecordsAffected, rgParams);
}

function PrepareConnection_ForMSAccess(oCon)
{
  // using 
  oCon.Provider = "Microsoft.ACE.OLEDB.12.0";
  oCon.Properties("Data Source") = "C:\\Program Files (x86)\\ESTOS\\UCServer\\database\\CtiServerDatabasejournal.mdb";
}

function PrepareConnection_ForJournalOSP(oCon)
{
  // using "non Full registered OLE DB provider"
  oCon.Provider = "MSDAOSP";
  oCon.Properties("Data Source") = "ECtiClient.CtiClient";
}

function DumpRecordSet(oRS)
{
  this.TRACE("Mode:        " + oRS.Mode);
  this.TRACE("Fields:      " + oRS.Fields.Count);
  this.TRACE("RecordCount: " + oRS.RecordCount);

  var cCount = 10; // dump a maximum of n rows
  oRS.MoveFirst();
  while (!oRS.EOF && 0 < cCount) 
  {
    this.DumpJournalRecord(oRS)

    oRS.MoveNext();
    cCount -= 1;
  }
}

function DumpFields (oRS)
{
  for (iIndex = 0; iIndex < oRS.Fields.Count; iIndex += 1)
  {
    this.TRACE("Field(" + iIndex + "): " + oRS.Fields(iIndex).Name);
  }
}

function DumpJournalRecord (oRS)
{
  var strLine = "";
  strLine += oRS("ConnectionID"); // 0
  strLine += oRS("PhoneNumber").value; // 14
  strLine += ", " + oRS("ContactName").value; // 16
  strLine += ", " + oRS("ReadFlag").value; // 27
  this.TRACE(strLine);
}

function DumpRecord (oRS)
{
  var strLine = oRS(0);
  for (iIndex = 1; iIndex < oRS.Fields.Count; iIndex += 1)
  {
    if ("string" == typeof(oRS(iIndex).value))
    {
      if (10 < oRS(iIndex).value.length)
        strLine += ", " + oRS(iIndex).value.substring(0, 9);
        else
        strLine += ", " + oRS(iIndex);
    }
    else
    {
      strLine += ", " + oRS.Fields(iIndex).type;
    }
  }
  this.TRACE(strLine);
}

function TRACE (varMsg)
{
  if (null == this.m_oResultFile)
  {
    WScript.Echo(varMsg);
  }
  else
  {
    this.m_oResultFile.Write(varMsg + "\n");
  }
}

function Run()
{
  // local variables
  var cstrName = "CJournal";
  var cstrDescription = "Simple Journal access using MSDAOSP, MS";

  try
  {
    this.TestBind();
    this.TestGetObject();

    // this.UsingCommand();
  }
  catch (e)
  {
    this.m_lRetC = e.number;

    var strUnsignedHexNumber;
    if (0 > e.number)
      strUnsignedHexNumber = "0x" + (0x100000000 + e.number).toString(16);
      else
      strUnsignedHexNumber = "0x" + e.number.toString(16);

    var strMessage = "Exception caught: " + e.description + ", " + strUnsignedHexNumber;
    this.TRACE(strMessage);
  }

  finally
  {
    switch (this.m_lRetC)
    {
    case 0:
      var strMessage = "all tests succeeded";
      WScript.Echo(strMessage);
      break;

    default:
      var strMessage = "at least one failed";
      WScript.Echo(strMessage);
      break;
    }
  }

  return this.m_lRetC;
}
