VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "edbConnection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Dim WithEvents mydbCon As ETapiSrvDBConnnect.Connection
Attribute mydbCon.VB_VarHelpID = -1

Public Function Init(ByVal strServer As String)
        
    ' Parameter
    ' strServer: ServerName of the TAPI-Server
    ' IPort    : Portnumber which edbcon has to connect to the TAPI-Server on
    '            (7203 is the default one and should be used here usually)
    ' Username : Name of the user to log in to the TAPI-Server
    ' Password : Password of the user
    ' strDBName: Name of the connector. Give here a string to identify your database in the system.
    ' IType    : One of three possibilities:
    '            - 0: Your database will only get events from the server, when an incoming phonenumber is searched.
    '            - CON_PHONEBOOK: Your database will be treated as a phonebook. This means, the server only sends events
    '              if no other database contains records for the searched contact/telephonenumber (low priority)
    '              and the name of the connector given by strDBName will be listed in the phonebook assistant of ProCall.
    '            - CON_OTHERDB: Your database will be treated as a normal database. It will get events on every
    '              search request to the server.
    ' IFlags    : CAP_INEXACTMATCH: If IType is set to CON_PHONEBOOK then you can set this flag. It tells the server and ProCall,
    '             that your database supports an inexact search pattern. Set this flag if the exact/inexact search buttons should
    '             be visible in the phonebook assistant. Otherwise the buttons are hidden.
    
    If mydbCon.Connect(strServer, 7222, "", "", "VisualBasic Demoplugin", ETapiSrvDBConnnect.CON_PHONEBOOK, 0) <> 0 Then
        MsgBox "connect failed"
    End If
        
End Function
Public Function DoExit()
        
    Call mydbCon.Disconnect
      
End Function


Private Sub Class_Initialize()
    Set mydbCon = New ETapiSrvDBConnnect.Connection
End Sub

Private Sub Class_Terminate()
    Set mydbCon = Nothing
End Sub

' Will be fired, when a USer is searching for a Contact by a specific Number or the Server tries to get Information
' about an incoming call number.
Private Function mydbCon_FindNumber(ByVal strNumberSC As String, ByVal Contact As ETapiSrvDBConnnect.IContact) As Long
    mydbCon_FindNumber = 1 'notfound
    If strNumberSC = "+498151122456" Then
        Contact.DisplayName = "Alois Maier - First GmbH"
        Contact.FirstName = "Alois"
        Contact.LastName = "Maier"
        Contact.PhoneBusiness = "+498151122456"
        Contact.PhoneBusiness2 = "+49 (30) 12345679"
        Contact.AddressStreet = "Leopoldstr. 104"
        Contact.AddressPostalCode = "81456"
        Contact.AddressCity = "Mnchen"
        Contact.AddressCountry = "Deutschland"
        Contact.AddressState = "Bayern"
        Contact.Company = "BLV Gmbh"
        
        Form1.List1.AddItem "Found : " + strNumberSC + " as " + Contact.DisplayName, 0
        
        mydbCon_FindNumber = 0
    End If
    
    
End Function

' Will be fired, when the User is searching for a Contact specified by the IFindOptions.
Private Function mydbCon_FindContacts(ByVal FindOptions As ETapiSrvDBConnnect.IFindOptions, ByVal Contacts As ETapiSrvDBConnnect.IContacts) As Long

    mydbCon_FindContacts = 0 'not found
    
    Form1.List1.AddItem "FindOptions : " + FindOptions.LastName + ", " + FindOptions.FirstName + ", " + FindOptions.StreetAddress + ", " + FindOptions.ZIPCodeOrCity + ", " + FindOptions.PhoneNo + ", " + FindOptions.DatabaseName, 0
        
    Dim ContactA As ETapiSrvDBConnnect.IContact
    Dim ContactB As ETapiSrvDBConnnect.IContact
    
    Set ContactA = New ETapiSrvDBConnnect.Contact
    ContactA.DisplayName = "Alois Maier - First GmbH"
    ContactA.FirstName = "Alois"
    ContactA.LastName = "Maier"
    ContactA.PhoneBusiness = "+498151122456"
    ContactA.PhoneBusiness2 = "+49 (30) 12345679"
    ContactA.AddressStreet = "Leopoldstr. 104"
    ContactA.AddressPostalCode = "81456"
    ContactA.AddressCity = "Mnchen"
    ContactA.AddressCountry = "Deutschland"
    ContactA.AddressState = "Bayern"
    ContactA.Company = "BLV Gmbh"
        
    Set ContactB = New ETapiSrvDBConnnect.Contact
    ContactB.DisplayName = "Barbara Huber - Second AG"
    ContactB.FirstName = "Barbara"
    ContactB.LastName = "Huber"
    ContactB.PhoneBusiness = "+498151789456"
    ContactB.PhoneBusiness2 = "+49 (89) 789456"
    ContactB.AddressStreet = "Arnulfstrae 30"
    ContactB.AddressPostalCode = "80589"
    ContactB.AddressCity = "Mnchen"
    ContactB.AddressCountry = "Deutschland"
    ContactB.AddressState = "Bayern"
    ContactB.Company = "Second AG"
    
    Contacts.Add ContactA
    Contacts.Add ContactB
    
    For Each Contact In Contacts
        Form1.List1.AddItem "Found Contact: " + strNumberSC + " as " + Contact.DisplayName, 1
    Next
    
    mydbCon_FindContacts = Contacts.Count

End Function
