// MFC_ATL_ClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MFC_ATL_Client.h"
#include "MFC_ATL_ClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

BEGIN_DISPATCH_MAP(CMFC_ATL_ClientDlg, CDialog)
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnCNCallOffering", 0x01, OnCNCallOffering, VT_EMPTY, VTS_DISPATCH )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnReconnect",      0x02, OnReconnect,      VT_EMPTY, VTS_NONE )
	DISP_FUNCTION_ID(CMFC_ATL_ClientDlg, "OnDisconnect",     0x03, OnDisconnect,     VT_EMPTY, VTS_NONE )
END_DISPATCH_MAP()

BEGIN_INTERFACE_MAP(CMFC_ATL_ClientDlg, CDialog)
	INTERFACE_PART(CMFC_ATL_ClientDlg, ENETSNLib::DIID__IApplicationEvents, Dispatch)
END_INTERFACE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg dialog
CMFC_ATL_ClientDlg::CMFC_ATL_ClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMFC_ATL_ClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFC_ATL_ClientDlg)
	//}}AFX_DATA_INIT
	EnableAutomation();
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_TransferOption = toCStrTx; // toMsgBox
	m_dwCookie = 0xfefefefe;
}

CMFC_ATL_ClientDlg::~CMFC_ATL_ClientDlg()
{
}

void CMFC_ATL_ClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFC_ATL_ClientDlg)
	DDX_Control(pDX, IDC_RBLISTBOX, m_rbListBox);
	DDX_Control(pDX, IDC_RBMESSAGEBOX, m_rbMessageBox);
	DDX_Control(pDX, IDC_RBFIRSTLINE, m_rbFirstLine);
	DDX_Control(pDX, IDC_RBSECONDLINE, m_rbSecondLine);
	DDX_Control(pDX, IDC_RBALLLINES, m_rbAllLines);
	DDX_Control(pDX, IDC_USEREG4USER, m_cbUseRegUser);
	DDX_Control(pDX, IDC_USEREG4SERVER, m_cbUseRegServer);
	DDX_Control(pDX, IDC_EDITUSERPASSWD, m_eUserPasswd);
	DDX_Control(pDX, IDC_EDITUSERNAME, m_eUserName);
	DDX_Control(pDX, IDC_EDITSERVERPORT, m_eServerPort);
	DDX_Control(pDX, IDC_EDITSERVERADRESS, m_eServerAddress);
	DDX_Control(pDX, IDC_CALLLIST, m_lbCallList);
	DDX_Control(pDX, IDC_CMDDIAL, m_bDial);
	DDX_Control(pDX, IDC_EDITFN, m_eFromNumber);
	DDX_Control(pDX, IDC_EDITTN, m_eToNumber);
	DDX_Control(pDX, IDC_SERVERVER, m_cbServerVer);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMFC_ATL_ClientDlg, CDialog)
	//{{AFX_MSG_MAP(CMFC_ATL_ClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_RBLISTBOX, OnRblistbox)
	ON_BN_CLICKED(IDC_RBMESSAGEBOX, OnRbmessagebox)
	ON_BN_CLICKED(IDC_USEREG4SERVER, OnUsereg4server)
	ON_BN_CLICKED(IDC_USEREG4USER, OnUsereg4user)
	ON_BN_CLICKED(IDC_CMDDIAL, OnCmddial)
	ON_BN_CLICKED(IDC_HANGUP, &CMFC_ATL_ClientDlg::OnBnClickedHangup)
	ON_CBN_SELENDOK(IDC_SERVERVER, &CMFC_ATL_ClientDlg::OnCbnSelendokServerver)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFC_ATL_ClientDlg message handlers
BOOL CMFC_ATL_ClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	m_cbServerVer.SetCurSel(0);

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	SetState(ssInitialize); // Preset all controls to their default state

	return TRUE;  // return TRUE  unless you set the focus to a control
}


// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMFC_ATL_ClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CMFC_ATL_ClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CMFC_ATL_ClientDlg::OnRblistbox() 
{
	m_TransferOption = toCStrTx;
}

void CMFC_ATL_ClientDlg::OnRbmessagebox() 
{
	m_TransferOption = toMsgBox;
}

void CMFC_ATL_ClientDlg::OnUsereg4server() 
{
	SetState(ssNormal); //Update View
}

void CMFC_ATL_ClientDlg::OnUsereg4user() 
{
	SetState(ssNormal); //Update View
}

HRESULT CMFC_ATL_ClientDlg::ReleaseApplication ()
{
	if (m_spApp)
	{
		Unadvise();

		// Destroy Application object to disconnect
		m_spApp.Release();
		m_lbCallList.AddString(_T("--- Application freed ---"));
		SetState(ssNormal);
	}

	return NOERROR;
}

BOOL CMFC_ATL_ClientDlg::Unadvise ()
{
	BOOL bRetC = FALSE;
	if (0xfefefefe != m_dwCookie)
		bRetC = ::AfxConnectionUnadvise(m_spApp.GetInterfacePtr (), ENETSNLib::DIID__IApplicationEvents, GetIDispatch(FALSE), FALSE, m_dwCookie);

	m_dwCookie = 0xfefefefe;
	return bRetC;
}

void CMFC_ATL_ClientDlg::OnCmddial()
{
	CString csFromNumber, csToNumber;
	// Retrieve information from controls
	m_eFromNumber.GetWindowText(csFromNumber);
	m_eToNumber.GetWindowText(csToNumber);

	try
	{
		m_spApp->MakeCall((LPCTSTR)csFromNumber, (LPCTSTR)csToNumber);
	}
	catch (const _com_error& e)
	{
		// Simple error handling: just display the information provided by ENetSN
		AfxMessageBox((LPCTSTR) e.Description());
	}
}

void CMFC_ATL_ClientDlg::OnBnClickedHangup()
{
	// Retrieve information from controls
	CString csFromNumber;
	m_eFromNumber.GetWindowText(csFromNumber);

	try
	{
		m_spApp->DropCall ((LPCTSTR)csFromNumber);
	}
	catch (const _com_error& e)
	{
		// Simple error handling: just display the information provided by ENetSN
		AfxMessageBox((LPCTSTR) e.Description());
	}
}

void CMFC_ATL_ClientDlg::SetState(tState aState)
{

	// Enable/disable form controls

	switch (aState)
	{
	case ssInitialize:	// Set initial button states
		m_cbUseRegServer.SetCheck(1);
		m_eServerAddress.SetWindowText(_T(""));
		m_eServerPort.SetWindowText(_T(""));

		m_cbUseRegUser.SetCheck(1);
		m_eUserName.SetWindowText(_T(""));
		m_eUserPasswd.SetWindowText(_T(""));

		m_rbSecondLine.SetCheck(1);

		CheckDlgButton(IDC_RBLISTBOX, true);

		m_eFromNumber.SetWindowText(_T(""));
		m_eToNumber.SetWindowText(_T(""));

		// recursive call to set the correct enabled-states
		SetState(ssNormal);
		break;
	case ssNormal:	// Normal state, not connected
		// Server and Login data boxes
		m_cbUseRegServer.EnableWindow(true);
		m_eServerAddress.EnableWindow(!m_cbUseRegServer.GetCheck());
		m_eServerPort.EnableWindow(!m_cbUseRegServer.GetCheck());

		m_cbUseRegUser.EnableWindow(true);
		m_eUserName.EnableWindow(!m_cbUseRegUser.GetCheck());
		m_eUserPasswd.EnableWindow(!m_cbUseRegUser.GetCheck());

		// Radiobuttons
		m_rbFirstLine.EnableWindow(true);
		m_rbSecondLine.EnableWindow(true);
		m_rbAllLines.EnableWindow(true);

		m_rbListBox.EnableWindow(false);
		m_rbMessageBox.EnableWindow(false);

		m_bDial.EnableWindow(false);
		m_eFromNumber.EnableWindow(false);
		m_eToNumber.EnableWindow(false);

		// Listbox
		m_lbCallList.EnableWindow(false);

		break;
	case ssConnected: // Connected state
		// GroupBoxes
		m_cbUseRegServer.EnableWindow(false);
		m_eServerAddress.EnableWindow(false);
		m_eServerPort.EnableWindow(false);

		m_cbUseRegUser.EnableWindow(false);
		m_eUserName.EnableWindow(false);
		m_eUserPasswd.EnableWindow(false);

		// Radiobuttons
		m_rbFirstLine.EnableWindow(false);
		m_rbSecondLine.EnableWindow(false);
		m_rbAllLines.EnableWindow(false);

		m_rbListBox.EnableWindow(true);
		m_rbMessageBox.EnableWindow(true);

		m_bDial.EnableWindow(true);
		m_eFromNumber.EnableWindow(true);
		m_eToNumber.EnableWindow(true);

		// Listbox
		m_lbCallList.EnableWindow(true);
		break;
	}
}

void CMFC_ATL_ClientDlg::OnCbnSelendokServerver ()
{
	const int iCurSel = m_cbServerVer.GetCurSel();
	if (0 > iCurSel)
		return;

	try
	{
		ReleaseApplication();

		CString strServerProID;
		m_cbServerVer.GetLBText(iCurSel, strServerProID);
		if ("NONE" != strServerProID)
		{
			// Create instance
			HRESULT hr = m_spApp.CreateInstance (strServerProID);
			if (FAILED(hr))
				_com_issue_error(hr);

			// Advise event sink
			::AfxConnectionAdvise(m_spApp.GetInterfacePtr(), ENETSNLib::DIID__IApplicationEvents, GetIDispatch(FALSE), FALSE, &m_dwCookie);

			if (!m_cbUseRegServer.GetCheck())
			{
				CString csServerAddress, csServerPort;
				m_eServerAddress.GetWindowText(csServerAddress);
				m_eServerPort.GetWindowText(csServerPort);
				m_spApp->SetServer(_bstr_t(csServerAddress), _ttoi((LPCTSTR)csServerPort));
			}
			
			if (!m_cbUseRegUser.GetCheck())
			{
				CString csUserName, csUserPasswd;
				m_eUserName.GetWindowText(csUserName);
				m_eUserPasswd.GetWindowText(csUserPasswd);
				m_spApp->SetLogin((LPCTSTR)csUserName, (LPCTSTR)csUserPasswd);
			}

			ENETSNLib::ConnectOptions ConOp;
			if (m_rbFirstLine.GetCheck())
				ConOp = ENETSNLib::coFirstLine;
			else if (m_rbSecondLine.GetCheck())
				ConOp = ENETSNLib::coFirstAndSecondLine;
			else
				ConOp = ENETSNLib::coAllAvailableLines;

			m_spApp->Connect(ConOp);
				
			m_lbCallList.AddString(_T("--- Connection established ---"));
			m_lbCallList.AddString(_T("First Line: ") + m_spApp->GetFirstLine());
			m_lbCallList.AddString(_T("Second Line: ") + m_spApp->GetSecondLine());

			SetState(ssConnected);
		}
	}
	catch (const _com_error& e)
	{
		CComBSTR bstrMsg(FormatMessageFromModule(e, _T("ENetSN.dll")));
		::MessageBoxW(m_hWnd, (BSTR) bstrMsg, L"Exception: ", MB_OK);
	}
}

void CMFC_ATL_ClientDlg::OnDestroy()
{
	Unadvise();
	ReleaseApplication();
	__super::OnDestroy();
}

// _IApplicationEvents Implementation
HRESULT CMFC_ATL_ClientDlg::OnCNCallOffering (LPDISPATCH pDisp)
{
	ENETSNLib::ICallInformationPtr spCallInformation(pDisp);

	CString strInfo;
	ENETSNLib::IRemoteContactPtr pRC = spCallInformation->GetRemoteContact();
	switch(m_TransferOption)
	{
	case toMsgBox:
		strInfo.Format(_T("Received Information:\n")
			_T("\n---- CallInformation -----------\n")
			_T("PermanentLineID: \t%0X\n")
			_T("LinePhoneNumber: \t%ls\n")
			_T("DisplayName: \t%ls\n")
			_T("EMailAddress: \t%ls\n")
			_T("UserName: \t%ls\n")
			_T("PhoneNumber: \t%ls\n")
			_T("PhoneSecondary: \t%ls\n")
			_T("LocalNumber: \t%ls\n")
			_T("OutBound: \t%d\n")
			_T("\n---- RemoteContact -------------\n")
			_T("CurrentNumberSC: \t%ls\n")
			_T("DatabaseName: \t%ls\n")
			_T("EntryIDDB: \t%ls\n")
			_T("EntryIDStore: \t%ls\n")
			_T("EntryID: \t%ls\n")
			_T("DirectWebLink: \t%ls\n")
			_T("DisplayName: \t%ls\n")
			_T("FirstName: \t%ls\n")
			_T("LastName: \t%ls\n")
			_T("JobTitle: \t%ls\n")
			_T("Company: \t%ls\n")
			_T("Department: \t%ls\n")
			_T("OfficeRoomNumber: \t%ls\n")
			_T("AddressStreet: \t%ls\n")
			_T("AddressPostalCode: \t%ls\n")
			_T("AddressCity: \t%ls\n")
			_T("AddressState: \t%ls\n")
			_T("AddressCountry: \t%ls\n")
			_T("EMail: \t%ls\n")
			_T("WebPageURL: \t%ls\n")
			_T("PhoneBusiness: \t%ls\n")
			_T("PhoneBusiness2: \t%ls\n")
			_T("PhoneHome: \t%ls\n")
			_T("PhoneMobile: \t%ls\n")
			_T("PhonePager: \t%ls\n")
			_T("FaxBusiness: \t%ls\n")
			_T("FaxHome: \t%ls\n")
			_T("Notes: \t%ls\n")
			_T("Custom0: \t%ls\n")
			_T("Custom1: \t%ls\n")
			_T("Custom2: \t%ls\n")
			_T("Custom3: \t%ls\n")
			_T("Custom4: \t%ls\n")
			_T("Custom5: \t%ls\n")
			_T("Custom6: \t%ls\n")
			_T("Custom7: \t%ls\n")
			_T("Custom8: \t%ls\n")
			_T("Custom9: \t%ls\n"),
			spCallInformation->GetPermanentLineID(),
			spCallInformation->GetLinePhoneNumber().GetBSTR (),
			spCallInformation->GetDisplayName().GetBSTR (),
			spCallInformation->GetEMailAddress().GetBSTR (),
			spCallInformation->GetUserName().GetBSTR (),
			spCallInformation->GetPhoneNumber().GetBSTR (),
			spCallInformation->GetPhoneSecondary().GetBSTR (),
			spCallInformation->GetLocalNumber().GetBSTR (),
			spCallInformation->GetOutBound(),
			pRC->GetCurrentNumberSC().GetBSTR (),
			pRC->GetDatabaseName().GetBSTR (),
			pRC->GetEntryIDDB().GetBSTR (),
			pRC->GetEntryIDStore().GetBSTR (),
			pRC->GetEntryID().GetBSTR (),
			pRC->GetDirectWebLink().GetBSTR (),
			pRC->GetDisplayName().GetBSTR (),
			pRC->GetFirstName().GetBSTR (),
			pRC->GetLastName().GetBSTR (),
			pRC->GetJobTitle().GetBSTR (),
			pRC->GetCompany().GetBSTR (),
			pRC->GetDepartment().GetBSTR (),
			pRC->GetOfficeRoomNumber().GetBSTR (),
			pRC->GetAddressStreet().GetBSTR (),
			pRC->GetAddressPostalCode().GetBSTR (),
			pRC->GetAddressCity().GetBSTR (),
			pRC->GetAddressState().GetBSTR (),
			pRC->GetAddressCountry().GetBSTR (),
			pRC->GetEMail().GetBSTR (),
			pRC->GetWebPageURL().GetBSTR (),
			pRC->GetPhoneBusiness().GetBSTR (),
			pRC->GetPhoneBusiness2().GetBSTR (),
			pRC->GetPhoneHome().GetBSTR (),
			pRC->GetPhoneMobile().GetBSTR (),
			pRC->GetPhonePager().GetBSTR (),
			pRC->GetFaxBusiness().GetBSTR (),
			pRC->GetFaxHome().GetBSTR (),
			pRC->GetNotes().GetBSTR (),
			pRC->GetCustom0().GetBSTR (),
			pRC->GetCustom1().GetBSTR (),
			pRC->GetCustom2().GetBSTR (),
			pRC->GetCustom3().GetBSTR (),
			pRC->GetCustom4().GetBSTR (),
			pRC->GetCustom5().GetBSTR (),
			pRC->GetCustom6().GetBSTR (),
			pRC->GetCustom7().GetBSTR (),
			pRC->GetCustom8().GetBSTR (),
			pRC->GetCustom9().GetBSTR());
		AfxMessageBox(strInfo);
		break;

	case toCStrTx:
		strInfo.Format(_T("%ls (%ls) -> %ls (%ls)"),
			pRC->GetCurrentNumberSC().GetBSTR (),
			pRC->GetDisplayName().GetBSTR (),
			spCallInformation->GetLocalNumber().GetBSTR (),
			spCallInformation->GetDisplayName().GetBSTR ());
		m_lbCallList.AddString(strInfo);

		// test reentrace
		// m_spApp->SetLogin(L"", L"");
		break;
	}

	return NOERROR;
}

HRESULT CMFC_ATL_ClientDlg::OnDisconnect (void)
{
	CString strInfo = "Connection to TAPI-Server lost !";
	switch(m_TransferOption)
	{
	case toMsgBox:
		AfxMessageBox(strInfo);
		break;

	case toCStrTx:
		m_lbCallList.AddString(strInfo);
		break;
	}

	return NOERROR;
}

HRESULT CMFC_ATL_ClientDlg::OnReconnect (void)
{
	CString strInfo = "TAPI-Server reconnected.";
	switch (m_TransferOption)
	{
	case toMsgBox:
		AfxMessageBox(strInfo);
		break;

	case toCStrTx:
		m_lbCallList.AddString(strInfo);
		break;
	}

	return NOERROR;
}

BSTR CMFC_ATL_ClientDlg::FormatMessageFromModule(
	const _com_error& e,
	LPCTSTR           szModule)
{
	_bstr_t bstrMsg(e.Description().GetBSTR ());
	bstrMsg += L"\r\n";
	const HRESULT hr = e.Error();
	if (FACILITY_ITF == HRESULT_FACILITY(hr))
	{
		TCHAR* pszMsg = NULL;
		::FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER|FORMAT_MESSAGE_FROM_HMODULE,
			::GetModuleHandle(szModule),
			hr,
			MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
			(LPTSTR)&pszMsg,
			0,
			NULL);
		if (NULL != pszMsg)
		{
			bstrMsg += pszMsg;
			bstrMsg += L"\r\n";
			::LocalFree(pszMsg);
		}
		else
		{
			CString strMsg;
			strMsg.Format(_T("e.Error() == 0x%.8x"), hr);
			bstrMsg += (LPCTSTR) strMsg;
			bstrMsg += L"\r\n";
		}

	}
	else
	{
		bstrMsg += e.ErrorMessage();
		bstrMsg += L"\r\n";
	}

	bstrMsg +=  e.Source();
	return bstrMsg.Detach ();
}
